;
; HUFFLIB EXAMPLE 1
;
; 'cocacola.huf' is a multifile archive with the files
; 'cc1.bin', 'cc2.bin' and 'cc.txt'. The compression ratio was 30.34%
;
; Command row: huffman cc1.bin cc2.bin -tcc.txt cocacola.huf
;
;  or	       huffman -lcc.lst
;

 @program code,name

code:
 jsr hufflib[check_mem]  ; Check if there is free memory
 tst.w	 d0		 ; If 0, out of mem
 beq OutOfMem
 jsr graylib[on]	 ; Turn on grayscale
 jsr flib[clr_scr]	 ; Clear the b&w layer
 lea	 pic(PC),a0	 ; Make A0 point to huffman compressed data
 move.l  a6,a1		 ; Move the address to grayscale layer to A1
 moveq	 #1,d3		 ; File 1 (ie, file 2 of 3, cc2.bin)
 jsr hufflib[extract]	 ; Extract A0 -> A1
 lea	 $4440,a1	 ; Make A1 point to LCD_MEM. A0 still points to data
 clr.l	 d3		 ; Show b&w layer, file 0 (ie, file 1 of 3, cc1.bin)
 jsr hufflib[extract]	 ; Extract
 moveq	 #2,d3		 ; File 2 (ie, file 3 of 3, cc.txt)
 clr.l	 d4		 ; We want to display the first string
 moveq	 #56,d0 	 ; At X=56
 moveq	 #117,d1	 ; Y=117
 jsr hufflib[write_string]  ; Do it
 jsr flib[idle_loop]	 ; Wait for keypress
 jsr graylib[off]	 ; Remove grayscale
OutOfMem:
 rts			 ; Return to Fargo/TI-OS

pic    incbin "cocacola.huf"  ; Including the huffman compressed data

name   dc.b "Huffman example 1",0

 reloc_open
 add_library flib
 add_library graylib
 add_library hufflib
 reloc_close
 end
