;
; HUFFLIB EXAMPLE 2
;
; 'strings.huf' is a multifile archive with the files
; 'strings0.txt' and 'strings1.txt'
;
; Command row: huffman -tstrings0.txt -tstrings1.txt strings.huf
;
;  or	       huffman -lstrings.lst
;

 @program code,name

code:
 jsr flib[clr_scr]	   ; Clear screen
 lea	 hufdata(PC),a0    ; Make A0 point to compressed data
 moveq	 #10,d0 	   ; Set X coordinate to 10
 moveq	 #10,d1 	   ; Set Y coordinate to 10
 moveq	 #0,d3		   ; From file 0
 moveq	 #4,d4		   ; and string 4
 jsr hufflib[write_string] ; Write string
 moveq	 #24,d1 	   ; Set Y coordinate to 24 (D0 is still 10)
 moveq	 #1,d3		   ; From file 1
 moveq	 #1,d4		   ; and string 1
 jsr hufflib[write_string_inv] ; Write string, inverted colors
 jsr flib[idle_loop]
 rts

hufdata  incbin "strings.huf"

name:
 dc.b "Huffman example 2",0

 reloc_open
 add_library flib
 add_library hufflib
 reloc_close
 end
